// Rallypoints should be destroyed on leaving your team/getting killed
// Compass icons need to be looked at
// Doesn't seem to be setting angle on spawn so that you are facing your rallypoint

/*
	Reinforced Search and Destroy
	Attackers objective: Bomb 2 positions
	Defenders objective: Defend these 2 positions / Defuse planted bombs
	Round ends:	When bomb explodes or roundlength time is reached.
	Map ends:	When all rounds have been played.
	Respawning:	When player dies, they are placed in a timed reinforcement queue.  Time to reinforce (in seconds) is set by the server through b_obj_queueTime_<team>.

	Level requirements
	------------------
		Allied Spawnpoints:
			classname		mp_sd_spawn_attacker
			Allied players spawn from these. Place at least 16 of these relatively close together.

		Axis Spawnpoints:
			classname		mp_sd_spawn_defender
			Axis players spawn from these. Place at least 16 of these relatively close together.

		Spectator Spawnpoints:
			classname		mp_global_intermission
			Spectators spawn from these and intermission is viewed from these positions.
			Atleast one is required, any more and they are randomly chosen between.

		Bombzones:
			classname					trigger_multiple
			targetname					bombzone
			script_gameobjectname		bombzone
			script_bombmode_original	<if defined this bombzone will be used in the original bomb mode>
			script_bombmode_single		<if defined this bombzone will be used in the single bomb mode>
			script_bombmode_dual		<if defined this bombzone will be used in the dual bomb mode>
			script_team					Set to allies or axis. This is used to set which team a bombzone is used by in dual bomb mode.
			script_label				Set to A or B. This sets the letter shown on the compass in original mode.
			This is a volume of space in which the bomb can planted. Must contain an origin brush.

		Bomb:
			classname				trigger_lookat
			targetname				bombtrigger
			script_gameobjectname	bombzone
			This should be a 16x16 unit trigger with an origin brush placed so that it's center lies on the bottom plane of the trigger.
			Must be in the level somewhere. This is the trigger that is used when defusing a bomb.
			It gets moved to the position of the planted bomb model.

	Level script requirements
	-------------------------
		Team Definitions:
			game["allies"] = "american";
			game["axis"] = "german";
			This sets the nationalities of the teams. Allies can be american, british, or russian. Axis can be german.

			game["attackers"] = "allies";
			game["defenders"] = "axis";
			This sets which team is attacking and which team is defending. Attackers plant the bombs. Defenders protect the targets.

		If using minefields or exploders:
			maps\mp\_load::main();

	Optional level script settings
	------------------------------
		Soldier Type and Variation:
			game["american_soldiertype"] = "normandy";
			game["german_soldiertype"] = "normandy";
			This sets what character models are used for each nationality on a particular map.

			Valid settings:
				american_soldiertype	normandy
				british_soldiertype		normandy, africa
				russian_soldiertype		coats, padded
				german_soldiertype		normandy, africa, winterlight, winterdark

		Exploder Effects:
			Setting script_noteworthy on a bombzone trigger to an exploder group can be used to trigger additional effects.

	Note
	----
		Setting "script_gameobjectname" to "bombzone" on any entity in a level will cause that entity to be removed in any gametype that
		does not explicitly allow it. This is done to remove unused entities when playing a map in other gametypes that have no use for them.
*/

/*QUAKED mp_sd_spawn_attacker (0.0 1.0 0.0) (-16 -16 0) (16 16 72)
Attacking players spawn randomly at one of these positions at the beginning of a round.*/

/*QUAKED mp_sd_spawn_defender (1.0 0.0 0.0) (-16 -16 0) (16 16 72)
Defending players spawn randomly at one of these positions at the beginning of a round.*/

main()
{
	// Backdraft Specify game version and print out stuff to the console.
	game["mod_version"] = "1 By Backdraft.";
	println("^1***** Starting Objective *****");

	level.callbackStartGameType = ::Callback_StartGameType;
	level.callbackPlayerConnect = ::Callback_PlayerConnect;
	level.callbackPlayerDisconnect = ::Callback_PlayerDisconnect;
	level.callbackPlayerDamage = ::Callback_PlayerDamage;
	level.callbackPlayerKilled = ::Callback_PlayerKilled;
	maps\mp\gametypes\_callbacksetup::SetupCallbacks();

	level.autoassign = ::menuAutoAssign;
	level.allies = ::menuAllies;
	level.axis = ::menuAxis;
	level.spectator = ::menuSpectator;
	level.weapon = ::menuWeapon;
	level.endgameconfirmed = ::endMap;
}

Callback_StartGameType()
{
	level.splitscreen = isSplitScreen();

	// if this is a fresh map start, set nationalities based on cvars, otherwise leave game variable nationalities as set in the level script
	if(!isdefined(game["gamestarted"]))
	{
		// defaults if not defined in level script
		if(!isdefined(game["allies"]))
			game["allies"] = "american";
		if(!isdefined(game["axis"]))
			game["axis"] = "german";
		if(!isdefined(game["attackers"]))
			game["attackers"] = "allies";
		if(!isdefined(game["defenders"]))
			game["defenders"] = "axis";

		// server cvar overrides
		if(getCvar("scr_allies") != "")
			game["allies"] = getCvar("scr_allies");
		if(getCvar("scr_axis") != "")
			game["axis"] = getCvar("scr_axis");

		precacheStatusIcon("hud_status_dead");
		precacheStatusIcon("hud_status_connecting");
		precacheRumble("damage_heavy");
		precacheShader("white");
		precacheShader("plantbomb");
		precacheShader("defusebomb");
		precacheShader("objective");
		precacheShader("objectiveA");
		precacheShader("objectiveB");
		precacheShader("bombplanted");
		precacheShader("objpoint_bomb");
		precacheShader("objpoint_A");
		precacheShader("objpoint_B");
		precacheShader("objpoint_star");
		precacheShader("hudStopwatch");
		precacheShader("hudstopwatchneedle");
		precacheString(&"MP_MATCHSTARTING");
		precacheString(&"MP_MATCHRESUMING");
		precacheString(&"MP_EXPLOSIVESPLANTED");
		precacheString(&"MP_EXPLOSIVESDEFUSED");
		precacheString(&"MP_ROUNDDRAW");
		precacheString(&"MP_TIMEHASEXPIRED");
		precacheString(&"MP_ALLIEDMISSIONACCOMPLISHED");
		precacheString(&"MP_AXISMISSIONACCOMPLISHED");
		//precacheString(&"MP_ALLIESHAVEBEENELIMINATED");
		//precacheString(&"MP_AXISHAVEBEENELIMINATED");
		precacheString(&"PLATFORM_HOLD_TO_PLANT_EXPLOSIVES");
		precacheString(&"PLATFORM_HOLD_TO_DEFUSE_EXPLOSIVES");
		precacheModel("xmodel/mp_tntbomb");
//		precacheModel("xmodel/mp_tntbomb_obj");

		// Backdraft Precache the skull and crossbones status icon.
		//precacheStatusIcon("death_suicide");
		precacheShader("hud_status_dead");
		precacheStatusIcon("gfx/hud/death_suicide.tga");
		//precacheShader("gfx/hud/hud@status_dead.tga");

		// Backdraft Spawn protect stuff.
		module\_mod_b_spawnprotect::precache();


		//BOT CLIENTS
		thread maps\mp\gametypes\_teams::addTestClients();
	}

	thread maps\mp\gametypes\_menus::init();
	thread maps\mp\gametypes\_serversettings::init();
	thread maps\mp\gametypes\_clientids::init();
	thread maps\mp\gametypes\_teams::init();
	thread maps\mp\gametypes\_weapons::init();
	thread maps\mp\gametypes\_scoreboard::init();
	thread maps\mp\gametypes\_killcam::init();
	thread maps\mp\gametypes\_shellshock::init();
//	thread maps\mp\gametypes\_hud_teamscore::init();
	thread maps\mp\gametypes\_deathicons::init();
	thread maps\mp\gametypes\_damagefeedback::init();
	thread maps\mp\gametypes\_healthoverlay::init();
	thread maps\mp\gametypes\_objpoints::init();
//	thread maps\mp\gametypes\_friendicons::init();
	thread friendicon_init();
	thread maps\mp\gametypes\_spectating::init();
	thread maps\mp\gametypes\_grenadeindicators::init();

	level.xenon = (getcvar("xenonGame") == "true");
	if(level.xenon) // Xenon only
		thread maps\mp\gametypes\_richpresence::init();
	else // PC only
		thread maps\mp\gametypes\_quickmessages::init();

	game["gamestarted"] = true;

	// Backdraft Set to auto_change to allow the player to change their name in the middle of the match.
	setClientNameMode("auto_change");


	// Backdraft Allow obj spawnpoints in the map.
	spawnpointname[0] = "mp_obj_spawn_attacker";
	spawnpointname[1] = "mp_sd_spawn_attacker";
	spawnpoints[0] = getentarray(spawnpointname[0], "classname");
	spawnpoints[1] = getentarray(spawnpointname[1], "classname");

	if(!spawnpoints[0].size)
	{
		game["map_ent_name"] = "sd";
		if ( !spawnpoints[1].size )
		{
			maps\mp\gametypes\_callbacksetup::AbortLevel();
			return;
		}
		for(i = 0; i < spawnpoints[1].size; i++)
			spawnpoints[1][i] placeSpawnpoint();
	}
	else
	{
		game["map_ent_name"] = "obj";
		for(i = 0; i < spawnpoints[0].size; i++)
			spawnpoints[0][i] placeSpawnpoint();
	}

	spawnpointname[0] = "mp_obj_spawn_defender";
	spawnpointname[1] = "mp_sd_spawn_defender";
	spawnpoints[0] = getentarray(spawnpointname[0], "classname");
	spawnpoints[1] = getentarray(spawnpointname[1], "classname");

	if(!spawnpoints[0].size)
	{
		if ( !spawnpoints[1].size )
		{
			maps\mp\gametypes\_callbacksetup::AbortLevel();
			return;
		}
		for(i = 0; i < spawnpoints[1].size; i++)
			spawnpoints[1][i] placeSpawnpoint();
	}
	else
		for(i = 0; i < spawnpoints[0].size; i++)
			spawnpoints[0][i] placeSpawnpoint();


	// Backdraft Change the effects.
	//level._effect["bombexplosion"] = loadfx("fx/explosions/v2_exlosion.efx");
	level._effect["hit_phelmet"] = loadfx("fx/impacts/small_metalhit.efx");
	level._effect["bombexplosion"] = loadfx("fx/props/barrelexp.efx");

	// Backdraft Allow obj map entities.
	allowed[0] = "sd";
	allowed[1] = "bombzone";
	allowed[2] = "blocker";
	allowed[3] = "obj";
	maps\mp\gametypes\_gameobjects::main(allowed);



	if(!isdefined(game["timepassed"]))
		game["timepassed"] = 0;

	level.roundlimit = cvarBounds( "scr_obj_roundlimit", "int", 4, 0, undefined );
	setCvar("ui_obj_roundlimit", level.roundlimit);
	makeCvarServerInfo("ui_obj_roundlimit", "0");

	level.roundlength = cvarBounds( "scr_obj_roundlength", "int", 12, 1, 60 );
	level.graceperiod = cvarBounds( "scr_obj_graceperiod", "int", 15, 0, 60 );

	level.battlerank = cvarBounds( "scr_battlerank", "int", 1, 0, 1 );
	setCvar("ui_battlerank", level.battlerank);
	makeCvarServerInfo("ui_battlerank", "0");

	// Backdraft HERE
	//cvarBounds( "scr_shellsock", "int", 1, 0, 1 );
	//setCvar("ui_shellshock", getCvar("scr_shellshock"));
	//makeCvarServerInfo("ui_shellshock", "0");

	if(!isDefined(game["compass_range"]))		// set up the compass range.
		game["compass_range"] = 1024;		
	setCvar("cg_hudcompassMaxRange", game["compass_range"]);

	cvarBounds( "scr_drophealth", "int", 1, 0, 1 );

	// Backdraft HERE
	//level.killcam = cvarBounds( "scr_killcam", "int", 1, 0, 1 );
	//setCvar("scr_killcam", level.killcam, true);

	level.teambalance = cvarBounds( "scr_teambalance", "int", 0, 0, 1 );
	level.lockteams = false;

	level.allowfreelook = cvarBounds( "scr_freelook", "int", 0, 0, 1 );
	level.allowenemyspectate = cvarBounds( "scr_spectateenemy", "int", 0, 0, 1 );
	level.drawfriend = cvarBounds( "scr_drawfriend", "int", 1, 0, 1 );

	// Backdraft Define obj cvar defaults.
	setCvar( "modversion", game["mod_version"], true );
	level.queueTime_allies = cvarBounds( "b_obj_queueTime_allies", "int", 0, 1, 99 );
	level.queueTime_axis = cvarBounds( "b_obj_queueTime_axis", "int", 0, 1, 99 );
	cvarBounds( "b_spawn_protect_allies", "int", 0, 0, 99 );
	cvarBounds( "b_spawn_protect_axis", "int", 0, 0, 99 );
	cvarBounds( "b_spawn_protect_noShoot", "int", 0, 0, 1 );
	cvarBounds( "b_obj_obj_destroyBoth", "int", 1, 0, 1 ); level.obj_destroyed = 0;
	cvarBounds( "b_obj_bomb_arm", "float", 3, 0, 99 );
	cvarBounds( "b_obj_bomb_defuse", "float", 8, 0, 99 );
	cvarBounds( "b_obj_bomb_time", "int", 40, 1, 99 );
	cvarBounds( "b_obj_bomb_blow_points", "int", 4, 0 );
	cvarBounds( "b_obj_bomb_arm_points", "int", 2, 0 );
	cvarBounds( "b_obj_bomb_defuse_points", "int", 2, 0 );
	cvarBounds( "b_obj_bomb_suddenDeath", "int", 1, 0, 1 );
	cvarBounds( "b_obj_latejoin_penalty", "int", 0, 0, 0 );
	cvarBounds( "b_obj_switchteam_penalty", "int", 0, 0, 0 );
	cvarBounds( "b_obj_suicide_penalty", "int", 0, 0, 0 );
	cvarBounds( "b_clip_default", "int", 2, 0 );
	cvarBounds( "b_player_health", "int", 100, 0, 1000 );
	level.player_lives["allies"] = cvarBounds( "b_player_lives_allies", "int", 0, 0, 99 );
	level.player_lives["axis"] = cvarBounds( "b_player_lives_axis", "int", 0, 0, 99 );
	cvarBounds( "b_player_tkmode", "int", 0, 0 );
	cvarBounds( "b_player_tk_spawnPenalty", "int", 0, 0 );
	cvarBounds( "b_player_tklimit", "int", 5, 0 );
	cvarBounds( "b_limitedlives_lateJoin", "int", 0, 0, 0 );
	cvarBounds( "b_corpse_timeout", "float", 0, 0 );
	cvarBounds( "b_testbots", "int", 0, 0 );
	cvarBounds( "b_antiDoorBlock", "int", 0, 0, 1 );


	if(!isdefined(game["state"]))
		game["state"] = "playing";
	if(!isdefined(game["roundsplayed"]))
		game["roundsplayed"] = 0;
	if(!isdefined(game["matchstarted"]))
		game["matchstarted"] = false;

	if(!isdefined(game["alliedscore"]))
		game["alliedscore"] = 0;
	setTeamScore("allies", game["alliedscore"]);

	if(!isdefined(game["axisscore"]))
		game["axisscore"] = 0;
	setTeamScore("axis", game["axisscore"]);

	// turn off ceasefire
	level.ceasefire = 0;
	setCvar("scr_ceasefire", "0");

	level.bombplanted[0] = false;
	level.bombplanted[1] = false;
	level.bombexploded[0] = false;
	level.bombexploded[1] = false;
	level.roundstarted = false;
	level.roundended = false;
	level.mapended = false;
	level.bombmode = 0;


	// Backdraft Death sounds.
	level.voices["german"] = 3;
	level.voices["american"] = 7;
	level.voices["russian"] = 6;
	level.voices["british"] = 6;

	// Backdraft Initialize the bomb model array.
	// Backdraft Might be causing problems.
	//level.bombmodel[0] = undefined;
	//level.bombmodel[1] = undefined;

	// Backdraft Null the GUID list.
	level.guid_list = undefined;

	// Backdraft Custom objective text.
	game["obj_text"]["attackers"] = "^1Objective version ^7" + game["mod_version"] + " ^7Destroy the objectives to win!";
	game["obj_text"]["defenders"] = "^1Objective version ^7" + game["mod_version"] + " ^7Prevent the objectives from being destroyed to win!";

	level.exist["allies"] = 0;
	level.exist["axis"] = 0;
	level.exist["teams"] = false;
	level.didexist["allies"] = false;
	level.didexist["axis"] = false;

	// Backdraft Health queue.
	level.healthqueue = [];
	level.healthqueuecurrent = 0;

	// Backdraft Start the bombzone logic
	thread bombzones(0);
	thread bombzones(1);
	//thread bombzones();

	thread startGame();
	thread updateGametypeCvars();
}

dummy()
{
	waittillframeend;

	if(isdefined(self))
		level notify("connecting", self);
}

Callback_PlayerConnect()
{
	thread dummy();

	self.statusicon = "hud_status_connecting";
	self waittill("begin");
	self.statusicon = "";

	level notify("connected", self);

	if(!isdefined(self.pers["team"]) && !level.splitscreen)
		iprintln(&"MP_CONNECTED", self);

	lpselfnum = self getEntityNumber();
	lpselfguid = self getGuid();
	logPrint("J;" + lpselfguid + ";" + lpselfnum + ";" + self.name + "\n");

	// Backdraft Initialize player variables.
	self.safe_death = false;
	self.addQueueTime = 0;
	self.addPQueueTime = 0;
	self.force_gracePeriod = 0;
	self.tk = 0;
	self.tk_reflect = false;
	self.lives_hud = false;
	if ( !isDefined( self.lives ) )
		self.lives = 0;

	// Backdraft Skip server info.
	self.pers["skipserverinfo"] = true;

	// Backdraft Check if GUID exists.
	self.isNew = true;
	tcheck = checkGUIDArray( lpselfguid );
	if ( tcheck == -1 )
	{
		level.guid_list = maps\mp\_utility::add_to_array( level.guid_list, lpselfguid );
		level.guid_list = maps\mp\_utility::add_to_array( level.guid_list, 0 );
	}
	else
		self.isNew = false;

	// Backdraft Limited lives.
	if ( self.lives_HUD == false )
	{
		self thread limitedLife_HUD();
		self.lives_HUD = true;
		self.given_lives = false;
	}

	if(game["state"] == "intermission")
	{
		spawnIntermission();
		return;
	}

	level endon("intermission");

	if(level.splitscreen)
	{
		if(isdefined(self.pers["weapon"]))
			scriptMainMenu = game["menu_ingame_onteam"];
		else
			scriptMainMenu = game["menu_ingame_spectator"];
	}
	else
		scriptMainMenu = game["menu_ingame"];

	if(isdefined(self.pers["team"]) && self.pers["team"] != "spectator")
	{
		self setClientCvar("ui_allow_weaponchange", "1");

		if(isdefined(self.pers["weapon"]))
			spawnPlayer();
		else
		{
			self.sessionteam = "spectator";

			spawnSpectator();

			if(self.pers["team"] == "allies")
			{
				self openMenu(game["menu_weapon_allies"]);
				scriptMainMenu = game["menu_weapon_allies"];
			}
			else
			{
				self openMenu(game["menu_weapon_axis"]);
				scriptMainMenu = game["menu_weapon_axis"];
			}
		}
	}
	else
	{
		self setClientCvar("ui_allow_weaponchange", "0");

		if(!level.xenon)
		{
			if(!isdefined(self.pers["skipserverinfo"]))
				self openMenu(game["menu_serverinfo"]);
			else
				self openMenu(game["menu_team"]);
		}
		else
			self openMenu(game["menu_team"]);

		self.pers["team"] = "spectator";
		self.sessionteam = "spectator";

		spawnSpectator();
	}

	self setClientCvar("g_scriptMainMenu", scriptMainMenu);
}

Callback_PlayerDisconnect()
{
	if(!level.splitscreen)
		iprintln(&"MP_DISCONNECTED", self);

	if(isdefined(self.pers["team"]))
	{
		if(self.pers["team"] == "allies")
			setplayerteamrank(self, 0, 0);
		else if(self.pers["team"] == "axis")
			setplayerteamrank(self, 1, 0);
		else if(self.pers["team"] == "spectator")
			setplayerteamrank(self, 2, 0);
	}

	lpselfnum = self getEntityNumber();
	lpselfguid = self getGuid();
	logPrint("Q;" + lpselfguid + ";" + lpselfnum + ";" + self.name + "\n");

	if ( !isDefined(self.lives) )
		self.lives = 0;

	if ( isDefined(self.pers["team"]) )					// Backdraft Sanity checks!
		if ( level.player_lives[self.pers["team"]] > 0 )
			updateGUIDArray( lpselfguid, self.lives );

	if(game["matchstarted"])
		level thread updateTeamStatus();
}

Callback_PlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime)
{
	if(self.sessionteam == "spectator")
		return;

	// Backdraft anti-doorblock code.
	if ( self module\_mod_b_doorblock::main( eAttacker, sMeansOfDeath ) ) return;

	// Do debug print if it's enabled
	if(getCvarInt("b_debugDamage"))
		println("client:" + self getEntityNumber() + " health:" + self.health + " damage:" + iDamage + " weapon:" + sWeapon + " meansOfDeath:" + sMeansOfDeath + " hitLoc:" + sHitLoc);

	// Backdraft Play some nice sound effects.
	if ( sHitLoc == "head" && sMeansOfDeath != "MOD_MELEE" )
	{
		self playSound("bullet_small_metal");
		playfx(level._effect["hit_phelmet"], vPoint);
	}

	// Backdraft Spawn protection.
	if ( self module\_mod_b_spawnprotect::checkForProtect() )
		return;

	// Don't do knockback if the damage direction was not specified
	if(!isdefined(vDir))
		iDFlags |= level.iDFLAGS_NO_KNOCKBACK;

	// Backdraft TK stuff.
	reflect = false;
	if ( isPlayer(eAttacker) )
	{
		if ( !isDefined(eAttacker.tk_reflect) )
			eAttacker.tk_reflect = false;

		if ( eAttacker.tk_reflect == true && ( self.pers["team"] == eAttacker.pers["team"] ) )
			reflect = true;
	}

	friendly = undefined;

	// check for completely getting out of the damage
	if(!(iDFlags & level.iDFLAGS_NO_PROTECTION))
	{
		if(isPlayer(eAttacker) && (self != eAttacker) && ((self.pers["team"] == eAttacker.pers["team"]) || reflect == true) )	// Backdraft Reflect stuff
		{
			if(level.friendlyfire == "0")
			{
				return;
			}
			else if(level.friendlyfire == "1")
			{
				// Make sure at least one point of damage is done
				if(iDamage < 1)
					iDamage = 1;

				self finishPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);

				// Shellshock/Rumble
				self thread maps\mp\gametypes\_shellshock::shellshockOnDamage(sMeansOfDeath, iDamage);
				self playrumble("damage_heavy");
			}
			else if(level.friendlyfire == "2")
			{
				eAttacker.friendlydamage = true;

				iDamage = int(iDamage * .5);

				// Make sure at least one point of damage is done
				if(iDamage < 1)
					iDamage = 1;

				eAttacker finishPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);
				eAttacker.friendlydamage = undefined;

				friendly = true;
			}
			else if(level.friendlyfire == "3")
			{
				eAttacker.friendlydamage = true;

				iDamage = int(iDamage * .5);

				// Make sure at least one point of damage is done
				if(iDamage < 1)
					iDamage = 1;

				self finishPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);
				eAttacker finishPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);
				eAttacker.friendlydamage = undefined;

				// Shellshock/Rumble
				self thread maps\mp\gametypes\_shellshock::shellshockOnDamage(sMeansOfDeath, iDamage);
				self playrumble("damage_heavy");

				friendly = true;
			}
		}
		else
		{
			// Make sure at least one point of damage is done
			if(iDamage < 1)
				iDamage = 1;

			self finishPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);

			// Shellshock/Rumble
			self thread maps\mp\gametypes\_shellshock::shellshockOnDamage(sMeansOfDeath, iDamage);
			self playrumble("damage_heavy");
		}

		if(isdefined(eAttacker) && eAttacker != self)
			eAttacker thread maps\mp\gametypes\_damagefeedback::updateDamageFeedback();
	}

	// Do debug print if it's enabled
	if(getCvarInt("g_debugDamage"))
	{
		println("client:" + self getEntityNumber() + " health:" + self.health +
			" damage:" + iDamage + " hitLoc:" + sHitLoc);
	}

	if(self.sessionstate != "dead")
	{
		lpselfnum = self getEntityNumber();
		lpselfguid = self getGuid();
		lpselfname = self.name;
		lpselfteam = self.pers["team"];
		lpattackerteam = "";

		if(isPlayer(eAttacker))
		{
			lpattacknum = eAttacker getEntityNumber();
			lpattackguid = eAttacker getGuid();
			lpattackname = eAttacker.name;
			lpattackerteam = eAttacker.pers["team"];
		}
		else
		{
			lpattacknum = -1;
			lpattackguid = "";
			lpattackname = "";
			lpattackerteam = "world";
		}

		if(isdefined(friendly))
		{
			lpattacknum = lpselfnum;
			lpattackname = lpselfname;
			lpattackguid = lpselfguid;
		}

		logPrint("D;" + lpselfguid + ";" + lpselfnum + ";" + lpselfteam + ";" + lpselfname + ";" + lpattackguid + ";" + lpattacknum + ";" + lpattackerteam + ";" + lpattackname + ";" + sWeapon + ";" + iDamage + ";" + sMeansOfDeath + ";" + sHitLoc + "\n");
	}
}

Callback_PlayerKilled(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime, deathAnimDuration)
{
	self endon("spawned");
	self notify("killed_player");

	if(self.sessionteam == "spectator")
		return;

	// Backdraft Initialize our variables so developer cvar doesn't yell at me.  :(
	if ( !isdefined(self.safe_death) )
		self.safe_death = false;

	// If the player was killed by a head shot, let players know it was a head shot kill
	if(sHitLoc == "head" && sMeansOfDeath != "MOD_MELEE")
		sMeansOfDeath = "MOD_HEAD_SHOT";

	// send out an obituary message to all clients about the kill
	obituary(self, attacker, sWeapon, sMeansOfDeath);

	self maps\mp\gametypes\_weapons::dropWeapon();
	self maps\mp\gametypes\_weapons::dropOffhand();

	if(!isdefined(self.switching_teams))
	{
		self.pers["deaths"]++;
		self.deaths = self.pers["deaths"];
		self.lives--;		// Backdraft Decrement lives.
	}

	// Backdraft If lives are 0, then set status icon to crossbones.
	if ( self.lives <= 0 && level.player_lives[self.pers["team"]] > 0 )
		self.statusicon = "gfx/hud/death_suicide.tga";
//		self.statusicon = "death_suicide";
	else
		self.statusicon = "hud_status_dead";
	self.sessionstate = "dead";

	lpselfnum = self getEntityNumber();
	lpselfguid = self getGuid();
	lpselfname = self.name;
	lpselfteam = self.pers["team"];
	lpattackerteam = "";

	attackerNum = -1;

	if(isPlayer(attacker))
	{
		if(attacker == self) // killed himself
		{
			doKillcam = false;

			// switching teams
			if(isdefined(self.switching_teams))
			{
				if((self.leaving_team == "allies" && self.joining_team == "axis") || (self.leaving_team == "axis" && self.joining_team == "allies"))
				{
					players = maps\mp\gametypes\_teams::CountPlayers();
					players[self.leaving_team]--;
					players[self.joining_team]++;

					if((players[self.joining_team] - players[self.leaving_team]) > 1)
					{
						attacker.pers["score"]--;
						attacker.score = attacker.pers["score"];
					}
				}
			}
			else if ( self.safe_death == false )
			{
				// Backdraft Suicide penalty.
				if ( getcvarint("b_obj_suicide_penalty") > 0 )
					self.addQueueTime += getcvarint("b_obj_suicide_penalty");

				attacker.pers["score"]--;
				attacker.score = attacker.pers["score"];
			}

			if(isdefined(attacker.friendlydamage))
				attacker iprintln(&"MP_FRIENDLY_FIRE_WILL_NOT");
		}
		else
		{
			attackerNum = attacker getEntityNumber();
			doKillcam = true;

			if(self.pers["team"] == attacker.pers["team"]) // killed by a friendly
			{
				attacker.pers["score"]--;
				attacker.score = attacker.pers["score"];

				// Backdraft Check for evil TK.
				attacker.tk++;
				attacker checkTKLimit();
			}
			else
			{
				attacker.pers["score"]++;
				attacker.score = attacker.pers["score"];
			}
		}

		lpattacknum = attacker getEntityNumber();
		lpattackguid = attacker getGuid();
		lpattackname = attacker.name;
		lpattackerteam = attacker.pers["team"];

		self notify("killed_player", attacker);
	}
	else // If you weren't killed by a player, you were in the wrong place at the wrong time
	{
		doKillcam = false;

		self.pers["score"]--;
		self.score = self.pers["score"];

		lpattacknum = -1;
		lpattackguid = "";
		lpattackname = "";
		lpattackerteam = "world";

		self notify("killed_player", self);
	}

	logPrint("K;" + lpselfguid + ";" + lpselfnum + ";" + lpselfteam + ";" + lpselfname + ";" + lpattackguid + ";" + lpattacknum + ";" + lpattackerteam + ";" + lpattackname + ";" + sWeapon + ";" + iDamage + ";" + sMeansOfDeath + ";" + sHitLoc + "\n");

	self.pers["weapon1"] = undefined;
	self.pers["weapon2"] = undefined;
	self.pers["spawnweapon"] = undefined;

	if(isdefined(self.bombtimer))
		self.bombtimer destroy();

	// Stop thread if map ended on this death
	if(level.mapended)
		return;

	// Backdraft Cool effects.
	if ( !isDefined(self.autobalance) && self.safe_death == false )
	{
		// Backdraft Detach helmet if conditions are met.
		if ( sMeansOfDeath == "MOD_HEAD_SHOT" || sMeansOfDeath == "MOD_EXPLOSIVE" || sMeansOfDeath == "MOD_GRENADE_SPLASH" || sMeansOfDeath == "MOD_PROJECTILE_SPLASH" )
		{
			self thread popObject( vDir, self getAttachModelName(1) );
			self detach( self getAttachModelName(1) );
		}
	}

	// Backdraft Sinking corpses!
	if ( getcvarfloat("b_corpse_timeout") == 0 )
	{
		body = self cloneplayer(deathAnimDuration);

		// Backdraft Play death sound.
		pTeam = self.pers["team"];
		body playSound( "generic_death_" + game[pTeam] + "_" + randomInt(level.voices[ game[pTeam] ]) );
	}
	else
		level thread bodyTimeout( self, getcvarfloat("b_corpse_timeout"), deathAnimDuration );

//	// Backdraft If lives are 0, then set status icon to crossbones.
//	if ( self.lives <= 0 && level.player_lives[self.pers["team"]] > 0 )
//		self.statusicon = "death_suicide";
//		//thread maps\mp\gametypes\_deathicons::addDeathicon(body, self.clientid, self.pers["team"], 5);
//		//self.statusicon = "gfx/hud/death_suicide.tga";

	//if(!isdefined(self.switching_teams))
	//{
	//	body = self cloneplayer(deathAnimDuration);
	//	thread maps\mp\gametypes\_deathicons::addDeathicon(body, self.clientid, self.pers["team"], 5);
	//}

	self.switching_teams = undefined;
	self.joining_team = undefined;
	self.leaving_team = undefined;

	level updateTeamStatus();

	// Make the player drop his weapon
	self maps\mp\gametypes\_weapons::dropWeapon();
	self maps\mp\gametypes\_weapons::dropOffhand();

	// Make the player drop health
//	self dropHealth();
	self.autobalance = undefined;
	self.safe_death = false;

	delay = 2;	// Delay the player becoming a spectator till after he's done dying
	wait delay;	// ?? Also required for Callback_PlayerKilled to complete before killcam can execute

	if(doKillcam && level.killcam && !level.roundended)
	{
		self maps\mp\gametypes\_killcam::killcam(attackerNum, delay, psOffsetTime);
		self thread joinQueue(self, true);
	}
	else
		self thread joinQueue(self);

	//currentorigin = self.origin;
	//currentangles = self.angles;
	//self thread spawnSpectator(currentorigin + (0, 0, 60), currentangles);
}

spawnPlayer()
{
	self endon("disconnect");
	self notify("spawned");
	self notify("end_respawn");

	resettimeout();

	// Backdraft Give them lives!
	self setLives();

	// Stop shellshock and rumble
	self stopShellshock();
	self stoprumble("damage_heavy");

	// Backdraft Don't let them cheat by joining a team with lots of lives then switching to one with not a lot of lives.
	if ( self.lives > level.player_lives[self.pers["team"]] )
	{
		self.lives = level.player_lives[self.pers["team"]];
		if ( self.lives == 0 )
			self notify( "llHUD_close" );
	}

	// Backdraft If they run out of lives, spawn them as a spectator.
	if ( self.lives <= 0 && level.player_lives[self.pers["team"]] > 0 )
	{
		iprintlnbold( "You have no lives left." );
		spawnSpectator( undefined, undefined, true );
		return;
	}

	//if(isdefined(self.spawned))
	//	return;

	self.sessionteam = self.pers["team"];
	self.sessionstate = "playing";
	self.spectatorclient = -1;
	self.archivetime = 0;
	self.psoffsettime = 0;
	self.statusicon = "";
	//self.maxhealth = 100;
	//self.health = self.maxhealth;
	self.friendlydamage = undefined;
	self.spawned = true;

	// Backdraft Set our health up.
	self.maxhealth = getcvarint("b_player_health");
	self.health = self.maxhealth;

	// Backdraft obj spawnpoints.
	if(self.pers["team"] == game["attackers"])
		spawnpointname = "mp_" + game["map_ent_name"] + "_spawn_attacker";
	else
		spawnpointname = "mp_" + game["map_ent_name"] + "_spawn_defender";

	spawnpoints = getentarray(spawnpointname, "classname");
	spawnpoint = maps\mp\gametypes\_spawnlogic::getSpawnpoint_Random(spawnpoints);

	if(isdefined(spawnpoint))
		self spawn(spawnpoint.origin, spawnpoint.angles);
	else
		maps\mp\_utility::error("NO " + spawnpointname + " SPAWNPOINTS IN MAP");

	level updateTeamStatus();

	if(!isdefined(self.pers["score"]))
		self.pers["score"] = 0;
	self.score = self.pers["score"];

	if(!isdefined(self.pers["deaths"]))
		self.pers["deaths"] = 0;
	self.deaths = self.pers["deaths"];

	if(!isdefined(self.pers["savedmodel"]))
		maps\mp\gametypes\_teams::model();
	else
		maps\mp\_utility::loadModel(self.pers["savedmodel"]);

	// Backdraft Require player to spawn with default weapons.
	self.pers["weapon1"] = undefined;
	self.pers["weapon2"] = undefined;

	if(isdefined(self.pers["weapon1"]) && isdefined(self.pers["weapon2"]))
	{
	 	self setWeaponSlotWeapon("primary", self.pers["weapon1"]);
		self setWeaponSlotAmmo("primary", 999);
		self setWeaponSlotClipAmmo("primary", 999);

	 	self setWeaponSlotWeapon("primaryb", self.pers["weapon2"]);
		self setWeaponSlotAmmo("primaryb", 999);
		self setWeaponSlotClipAmmo("primaryb", 999);

		self setSpawnWeapon(self.pers["spawnweapon"]);
	}
	else
	{
		self setWeaponSlotWeapon("primary", self.pers["weapon"]);
		self setWeaponSlotAmmo("primary", 999);
		self setWeaponSlotClipAmmo("primary", 999);

		self setSpawnWeapon(self.pers["weapon"]);
	}

	maps\mp\gametypes\_weapons::givePistol();
	maps\mp\gametypes\_weapons::giveGrenades();
	maps\mp\gametypes\_weapons::giveBinoculars();

	self.usedweapons = false;
	thread maps\mp\gametypes\_weapons::watchWeaponUsage();

//	if(level.bombplanted)
//		thread showPlayerBombTimer();

/*
	if(!level.splitscreen)
	{
		if(level.scorelimit > 0)
		{
			if(self.pers["team"] == game["attackers"])
				self setClientCvar("cg_objectiveText", &"MP_OBJ_ATTACKERS", level.scorelimit);
			else if(self.pers["team"] == game["defenders"])
				self setClientCvar("cg_objectiveText", &"MP_OBJ_DEFENDERS", level.scorelimit);
		}
		else
		{
			if(self.pers["team"] == game["attackers"])
				self setClientCvar("cg_objectiveText", &"MP_OBJ_ATTACKERS_NOSCORE");
			else if(self.pers["team"] == game["defenders"])
				self setClientCvar("cg_objectiveText", &"MP_OBJ_DEFENDERS_NOSCORE");
		}
	}
	else
	{
		if(self.pers["team"] == game["attackers"])
			self setClientCvar("cg_objectiveText", &"MP_DESTROY_THE_OBJECTIVE");
		else if(self.pers["team"] == game["defenders"])
			self setClientCvar("cg_objectiveText", &"MP_DEFEND_THE_OBJECTIVE");
	}
*/

	// Backdraft Prevent spawn killing by making the player invulnerable.
	self thread module\_mod_b_spawnprotect::main();

	// Backdraft Custom objective text.
	if(self.pers["team"] == game["attackers"])
		self setClientCvar( "cg_objectiveText", game["obj_text"]["attackers"] );
	else if(self.pers["team"] == game["defenders"])
		self setClientCvar( "cg_objectiveText", game["obj_text"]["defenders"] );

	waittillframeend;
	self notify("spawned_player");
}

spawnSpectator(origin, angles, keepTeam)
{
	self notify("spawned");

	resettimeout();

	// Backdraft If keepTeam is specified, don't change the team to spectator.  This is for when you lose all your lives.
	if ( !isDefined(keepTeam) )
		keepTeam = false;

	if ( keepTeam == false )
	{
		self.sessionteam = "spectator";
		self.pers["team"] = "spectator";
	}

	// Stop shellshock and rumble
	self stopShellshock();
	self stoprumble("damage_heavy");

	self.sessionstate = "spectator";
	self.spectatorclient = -1;
	self.archivetime = 0;
	self.psoffsettime = 0;
	self.friendlydamage = undefined;

	if(self.pers["team"] == "spectator")
		self.statusicon = "";

	if(!isdefined(self.skip_setspectatepermissions))
		maps\mp\gametypes\_spectating::setSpectatePermissions();

	if(isdefined(origin) && isdefined(angles))
		self spawn(origin, angles);
	else
	{
 		spawnpointname = "mp_global_intermission";
		spawnpoints = getentarray(spawnpointname, "classname");
		spawnpoint = maps\mp\gametypes\_spawnlogic::getSpawnpoint_Random(spawnpoints);

		if(isdefined(spawnpoint))
			self spawn(spawnpoint.origin, spawnpoint.angles);
		else
			maps\mp\_utility::error("NO " + spawnpointname + " SPAWNPOINTS IN MAP");
	}

	level updateTeamStatus();

	self.usedweapons = false;

	// Backdraft Spectator objective text.
	objtext = "^1obj version ^7" + game["mod_version"] + " ^1- www.iwnation.com/Hosted/Boco/index.html\n^7Attackers: " + game["attackers"] + " - Defenders: " + game["defenders"];
	self setClientCvar("cg_objectiveText", objtext);

/*
	self setClientCvar("cg_objectiveText", "");
*/
}

spawnIntermission()
{
	self notify("spawned");

	resettimeout();

	// Stop shellshock and rumble
	self stopShellshock();
	self stoprumble("damage_heavy");

	self.sessionstate = "intermission";
	self.spectatorclient = -1;
	self.archivetime = 0;
	self.psoffsettime = 0;
	self.friendlydamage = undefined;

	spawnpointname = "mp_global_intermission";
	spawnpoints = getentarray(spawnpointname, "classname");
	spawnpoint = maps\mp\gametypes\_spawnlogic::getSpawnpoint_Random(spawnpoints);

	if(isdefined(spawnpoint))
		self spawn(spawnpoint.origin, spawnpoint.angles);
	else
		maps\mp\_utility::error("NO " + spawnpointname + " SPAWNPOINTS IN MAP");
}

startGame()
{
	game["matchstarted"] = true;		// Backdraft Force the match to start.
	level.team_exist["allies"] = false;
	level.team_exist["axis"] = false;
	axisDead = false;
	alliesDead = false;

	level.starttime = getTime();
	thread startRound();


	for ( ;; )
	{
		// Backdraft Check for balanced teams.
		if ( level.roundstarted )
		{
			if ( level.player_lives["axis"] > 0 )
				if ( checkTeamExist("axis") )
					axisDead = checkTeamDead("axis");
			if ( level.player_lives["allies"] > 0 )
				if ( checkTeamExist("allies") )
					alliesDead = checkTeamDead("allies");

			if ( axisDead == true && alliesDead == true )
				level thread endRound("draw");
			else if ( axisDead == true )
				level thread endRound("allies");
			else if ( alliesDead == true )
				level thread endRound("axis");
		}
		wait 1;
	}
}

startRound()
{
	//level endon("bomb_planted");
	level endon("round_ended");

	if(!level.splitscreen)
		thread sayObjective();

	level.clock = newHudElem();
	level.clock.horzAlign = "left";
	level.clock.vertAlign = "top";
	level.clock.x = 8;
	level.clock.y = 2;
	level.clock.font = "default";
	level.clock.fontscale = 2;
	level.clock setTimer(level.roundlength * 60);

	if(game["matchstarted"])
	{
		level.clock.color = (.98, .827, .58);

		if((level.roundlength * 60) > level.graceperiod)
		{
			wait level.graceperiod;

			level notify("round_started");
			level.roundstarted = true;
			level.clock.color = (1, 1, 1);

/*	Backdraft No relevance to obj.
			// Players on a team but without a weapon show as dead since they can not get in this round
			players = getentarray("player", "classname");
			for(i = 0; i < players.size; i++)
			{
				player = players[i];

				if(player.sessionteam != "spectator" && !isdefined(player.pers["weapon"]))
					player.statusicon = "hud_status_dead";
			}
*/

			wait((level.roundlength * 60) - level.graceperiod);
		}
		else
		{
			level.roundstarted = true;
			wait(level.roundlength * 60);
		}
	}
	else
	{
		level.roundstarted = true;
		level.clock.color = (1, 1, 1);
		wait(level.roundlength * 60);
	}

	if(level.roundended)
		return;

	if ( getcvarint( "b_obj_bomb_suddenDeath" ) == 1 )
	{
		if ( !(getCvarInt( "b_obj_obj_destroyBoth" ) >= 1 && level.obj_destroyed == 0 ) )
		{
			if ( level.bombplanted[0] == true )
			{
				level waittill( "bomb_event", event );
				if ( event == "explode" )
				{
					level thread endRound( game["attackers"] );
					return;
				}
			}
			else if ( level.bombplanted[1] == true )
			{
				level waittill( "bomb_event2", event );
				if ( event == "explode" )
				{
					level thread endRound( game["attackers"] );
					return;
				}
			}
		}
	}

/*
	if(!level.exist[game["attackers"]] || !level.exist[game["defenders"]])
	{
		iprintln(&"MP_TIMEHASEXPIRED");
		level thread endRound("draw");
		return;
	}
*/

	iprintln(&"MP_TIMEHASEXPIRED");
	level thread endRound(game["defenders"]);
}

checkMatchStart()
{
	oldvalue["teams"] = level.exist["teams"];
	level.exist["teams"] = false;

	// If teams currently exist
	if(level.exist["allies"] && level.exist["axis"])
		level.exist["teams"] = true;

	// If teams previously did not exist and now they do
	if(!oldvalue["teams"] && level.exist["teams"])
	{
		if(!game["matchstarted"])
		{
			iprintln(&"MP_MATCHSTARTING");

			level notify("kill_endround");
			level.roundended = false;
			level thread endRound("reset");
		}
		else
		{
			iprintln(&"MP_MATCHRESUMING");

			level notify("kill_endround");
			level.roundended = false;
			level thread endRound("draw");
		}

		return;
	}
}

resetScores()
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];
		player.pers["score"] = 0;
		player.pers["deaths"] = 0;
	}

	game["alliedscore"] = 0;
	setTeamScore("allies", game["alliedscore"]);
	game["axisscore"] = 0;
	setTeamScore("axis", game["axisscore"]);
}

endRound(roundwinner)
{
	level endon("intermission");
	level endon("kill_endround");

	if(level.roundended)
		return;
	level.roundended = true;

	// Backdraft Reset the objective count.
	level.obj_destroyed = 0;

	// End bombzone threads and remove related hud elements and objectives
	level notify("round_ended");
	level notify("update_allhud_score");

	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(isdefined(player.progressbackground))
			player.progressbackground destroy();

		if(isdefined(player.progressbar))
			player.progressbar destroy();

		player unlink();
		player enableWeapon();
	}

	objective_delete(0);
	objective_delete(1);

	level thread announceWinner(roundwinner, 2);

	winners = "";
	losers = "";

	if(roundwinner == "allies")
	{
		game["alliedscore"]++;
		setTeamScore("allies", game["alliedscore"]);

		players = getentarray("player", "classname");
		for(i = 0; i < players.size; i++)
		{
			lpGuid = players[i] getGuid();
			if((isdefined(players[i].pers["team"])) && (players[i].pers["team"] == "allies"))
				winners = (winners + ";" + lpGuid + ";" + players[i].name);
			else if((isdefined(players[i].pers["team"])) && (players[i].pers["team"] == "axis"))
				losers = (losers + ";" + lpGuid + ";" + players[i].name);
		}
		logPrint("W;allies" + winners + "\n");
		logPrint("L;axis" + losers + "\n");
	}
	else if(roundwinner == "axis")
	{
		game["axisscore"]++;
		setTeamScore("axis", game["axisscore"]);

		players = getentarray("player", "classname");
		for(i = 0; i < players.size; i++)
		{
			lpGuid = players[i] getGuid();
			if((isdefined(players[i].pers["team"])) && (players[i].pers["team"] == "axis"))
				winners = (winners + ";" + lpGuid + ";" + players[i].name);
			else if((isdefined(players[i].pers["team"])) && (players[i].pers["team"] == "allies"))
				losers = (losers + ";" + lpGuid + ";" + players[i].name);
		}
		logPrint("W;axis" + winners + "\n");
		logPrint("L;allies" + losers + "\n");
	}

	wait 7;

	if(game["matchstarted"])
	{
		//checkScoreLimit();
		game["roundsplayed"]++;
		checkRoundLimit();
	}

/*
	if(!game["matchstarted"] && roundwinner == "reset")
	{
		game["matchstarted"] = true;
		thread resetScores();
		game["roundsplayed"] = 0;
	}
*/

	// Backdraft Give everybody max lives again.
	players = getentarray("player", "classname");
	for ( i = 0; i < players.size; i++ )
	{
		players[i] unlink();
		players[i] enableWeapon();
		if ( players[i].pers["team"] != "spectator" && level.player_lives[players[i].pers["team"]] > 0 )
			players[i].lives = level.player_lives[players[i].pers["team"]];
	}

/*
	game["timepassed"] = game["timepassed"] + ((getTime() - level.starttime) / 1000) / 60.0;

	checkTimeLimit();
*/

	if(level.mapended)
		return;
	level.mapended = true;

	// for all living players store their weapons
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(isdefined(player.pers["team"]) && player.pers["team"] != "spectator" && player.sessionstate == "playing")
		{
			weapon1 = player getWeaponSlotWeapon("primary");
			weapon2 = player getWeaponSlotWeapon("primaryb");
			current = player getCurrentWeapon();

			// A new weapon has been selected
			if(isdefined(player.oldweapon))
			{
				player.pers["weapon1"] = player.pers["weapon"];
				player.pers["weapon2"] = "none";
				player.pers["spawnweapon"] = player.pers["weapon1"];
			} // No new weapons selected
			else
			{
				if(!maps\mp\gametypes\_weapons::isMainWeapon(weapon1) && !maps\mp\gametypes\_weapons::isMainWeapon(weapon2))
				{
					player.pers["weapon1"] = player.pers["weapon"];
					player.pers["weapon2"] = "none";
				}
				else if(maps\mp\gametypes\_weapons::isMainWeapon(weapon1) && !maps\mp\gametypes\_weapons::isMainWeapon(weapon2))
				{
					player.pers["weapon1"] = weapon1;
					player.pers["weapon2"] = "none";
				}
				else if(!maps\mp\gametypes\_weapons::isMainWeapon(weapon1) && maps\mp\gametypes\_weapons::isMainWeapon(weapon2))
				{
					player.pers["weapon1"] = weapon2;
					player.pers["weapon2"] = "none";
				}
				else
				{
					assert(maps\mp\gametypes\_weapons::isMainWeapon(weapon1) && maps\mp\gametypes\_weapons::isMainWeapon(weapon2));

					if(current == weapon2)
					{
						player.pers["weapon1"] = weapon2;
						player.pers["weapon2"] = weapon1;
					}
					else
					{
						player.pers["weapon1"] = weapon1;
						player.pers["weapon2"] = weapon2;
					}
				}

				player.pers["spawnweapon"] = player.pers["weapon1"];
			}
		}
	}

	level notify("restarting");

	map_restart(true);
}

endMap()
{
	game["state"] = "intermission";
	level notify("intermission");

	if ( isdefined(level.bombmodel) )
	{
		if(isdefined(level.bombmodel[0]))
			level.bombmodel[0] stopLoopSound();
		if(isdefined(level.bombmodel[1]))
			level.bombmodel[1] stopLoopSound();
	}

	level.bombmodel = undefined;

	if(game["alliedscore"] == game["axisscore"])
		text = &"MP_THE_GAME_IS_A_TIE";
	else if(game["alliedscore"] > game["axisscore"])
		text = &"MP_ALLIES_WIN";
	else
		text = &"MP_AXIS_WIN";

	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		player closeMenu();
		player closeInGameMenu();
		player setClientCvar("cg_objectiveText", text);

		player spawnIntermission();
	}

	// set everyone's rank on xenon
	if(level.xenon)
	{
		players = getentarray("player", "classname");
		highscore = undefined;

		for(i = 0; i < players.size; i++)
		{
			player = players[i];

			if(!isdefined(player.score))
				continue;

			if(!isdefined(highscore) || player.score > highscore)
				highscore = player.score;
		}

		for(i = 0; i < players.size; i++)
		{
			player = players[i];

			if(!isdefined(player.score))
				continue;

			if(highscore <= 0)
				rank = 0;
			else
			{
				rank = int(player.score * 10 / highscore);
				if(rank < 0)
					rank = 0;
			}

			if(player.pers["team"] == "allies")
				setplayerteamrank(player, 0, rank);
			else if(player.pers["team"] == "axis")
				setplayerteamrank(player, 1, rank);
			else if(player.pers["team"] == "spectator")
				setplayerteamrank(player, 2, rank);
		}
		sendranks();
	}

	level.guid_array = undefined;		// Backdraft Yeah.
	wait 10;
	exitLevel(false);
}

/*
checkTimeLimit()
{
	if(level.timelimit <= 0)
		return;

	if(game["timepassed"] < level.timelimit)
		return;

	if(level.mapended)
		return;
	level.mapended = true;

	if(!level.splitscreen)
		iprintln(&"MP_TIME_LIMIT_REACHED");

	level thread endMap();
}

checkScoreLimit()
{
	if(level.scorelimit <= 0)
		return;

	if(game["alliedscore"] < level.scorelimit && game["axisscore"] < level.scorelimit)
		return;

	if(level.mapended)
		return;
	level.mapended = true;

	if(!level.splitscreen)
		iprintln(&"MP_SCORE_LIMIT_REACHED");

	level thread endMap();
}
*/

checkRoundLimit()
{
	if(level.roundlimit <= 0)
		return;

	if(game["roundsplayed"] < level.roundlimit)
		return;

	if(level.mapended)
		return;
	level.mapended = true;

	if(!level.splitscreen)
		iprintln(&"MP_ROUND_LIMIT_REACHED");

	level thread endMap();
}

updateGametypeCvars()
{
	for(;;)
	{
		roundlimit = getCvarInt("scr_obj_roundlimit");
		if(level.roundlimit != roundlimit)
		{
			level.roundlimit = roundlimit;
			setCvar("ui_obj_roundlimit", level.roundlimit);

			if(game["matchstarted"])
				checkRoundLimit();
		}

		roundlength = cvarBounds( "scr_obj_roundlength", "int", 10, 0, 60 );
		graceperiod = cvarBounds( "scr_obj_graceperiod", "int", 15, 0, 60 );

		wait 1;
	}
}

updateTeamStatus()
{
	wait 0;	// Required for Callback_PlayerDisconnect to complete before updateTeamStatus can execute

	resettimeout();

	oldvalue["allies"] = level.exist["allies"];
	oldvalue["axis"] = level.exist["axis"];
	level.exist["allies"] = 0;
	level.exist["axis"] = 0;

	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(isdefined(player.pers["team"]) && player.pers["team"] != "spectator" && player.sessionstate == "playing")
			level.exist[player.pers["team"]]++;
	}

	if(level.exist["allies"])
		level.didexist["allies"] = true;
	if(level.exist["axis"])
		level.didexist["axis"] = true;

	if(level.roundended)
		return;

/*
	// if both allies and axis were alive and now they are both dead in the same instance
	if(oldvalue["allies"] && !level.exist["allies"] && oldvalue["axis"] && !level.exist["axis"])
	{
		if(level.bombplanted)
		{
			// if allies planted the bomb, allies win
			if(level.planting_team == "allies")
			{
				iprintln(&"MP_ALLIEDMISSIONACCOMPLISHED");
				level thread endRound("allies");
				return;
			}
			else // axis planted the bomb, axis win
			{
				assert(game["attackers"] == "axis");
				iprintln(&"MP_AXISMISSIONACCOMPLISHED");
				level thread endRound("axis");
				return;
			}
		}

		// if there is no bomb planted the round is a draw
		iprintln(&"MP_ROUNDDRAW");
		level thread endRound("draw");
		return;
	}

	// if allies were alive and now they are not
	if(oldvalue["allies"] && !level.exist["allies"])
	{
		// if allies planted the bomb, continue the round
		if(level.bombplanted && level.planting_team == "allies")
			return;

		iprintln(&"MP_ALLIESHAVEBEENELIMINATED");
		level thread playSoundOnPlayers("mp_announcer_allieselim");
		level thread endRound("axis");
		return;
	}

	// if axis were alive and now they are not
	if(oldvalue["axis"] && !level.exist["axis"])
	{
		// if axis planted the bomb, continue the round
		if(level.bombplanted && level.planting_team == "axis")
			return;

		iprintln(&"MP_AXISHAVEBEENELIMINATED");
		level thread playSoundOnPlayers("mp_announcer_axiselim");
		level thread endRound("allies");
		return;
	}
*/
}

bombzones(bombnumber)
{
	level endon("round_ended");

	maperrors = [];

	if(level.splitscreen)
		level.barsize = 152;
	else
		level.barsize = 192;

	level.planttime[bombnumber] = getcvarint("b_obj_bomb_arm");		// seconds to plant a bomb
	level.defusetime[bombnumber] = getcvarint("b_obj_bomb_defuse");	// seconds to defuse a bomb

	level.bombplanted[bombnumber] = false;

	wait .2;

	bombzones = getentarray("bombzone", "targetname");
	array = [];

	for(i = 0; i < bombzones.size; i++)
	{
		bombzone = bombzones[i];

		if(isdefined(bombzone.script_bombmode_original) && isdefined(bombzone.script_label))
			array[array.size] = bombzone;
	}

	if(array.size == 2)
	{
		bombzone0 = array[0];
		bombzone1 = array[1];
		bombzone_A = undefined;
		bombzone_B = undefined;

		if(bombzone0.script_label == "A" || bombzone0.script_label == "a")
	 	{
	 		bombzone_A = bombzone0;
	 		bombzone_B = bombzone1;
	 	}
	 	else if(bombzone0.script_label == "B" || bombzone0.script_label == "b")
	 	{
	 		bombzone_A = bombzone1;
	 		bombzone_B = bombzone0;
	 	}
	 	else
	 		maperrors[maperrors.size] = "^1Bombmode original: Bombzone found with an invalid \"script_label\", must be \"A\" or \"B\"";

		if ( bombnumber == 0 )
		{
	 		objective_add(0, "current", bombzone_A.origin, "objectiveA");
			bombzone_A thread bombzone_think(bombzone_B, bombnumber);
			thread maps\mp\gametypes\_objpoints::addTeamObjpoint(bombzone_A.origin, "0", "allies", "objpoint_A");
			thread maps\mp\gametypes\_objpoints::addTeamObjpoint(bombzone_A.origin, "0", "axis", "objpoint_A");
		}
		else
		{
			bombzone_B thread bombzone_think(bombzone_A, bombnumber);
	 		objective_add(1, "current", bombzone_B.origin, "objectiveB");
			thread maps\mp\gametypes\_objpoints::addTeamObjpoint(bombzone_B.origin, "1", "allies", "objpoint_B");
			thread maps\mp\gametypes\_objpoints::addTeamObjpoint(bombzone_B.origin, "1", "axis", "objpoint_B");
		}
	}
	else if(array.size < 2)
		maperrors[maperrors.size] = "^1Bombmode original: Less than 2 bombzones found with \"script_bombmode_original\" \"1\"";
	else if(array.size > 2)
		maperrors[maperrors.size] = "^1Bombmode original: More than 2 bombzones found with \"script_bombmode_original\" \"1\"";

	bombtriggers = getentarray("bombtrigger", "targetname");
	if(bombtriggers.size < 1)
		maperrors[maperrors.size] = "^1No entities found with \"targetname\" \"bombtrigger\"";
	else if(bombtriggers.size > 1)
		maperrors[maperrors.size] = "^1More than 1 entity found with \"targetname\" \"bombtrigger\"";

	if(maperrors.size)
	{
		println("^1------------ Map Errors ------------");
		for(i = 0; i < maperrors.size; i++)
			println(maperrors[i]);
		println("^1------------------------------------");

		return;
	}

	bombtrigger = getent("bombtrigger", "targetname");
	bombtrigger maps\mp\_utility::triggerOff();

	// Kill unused bombzones and associated script_exploders

	accepted = [];
	for(i = 0; i < array.size; i++)
	{
		if(isdefined(array[i].script_noteworthy))
			accepted[accepted.size] = array[i].script_noteworthy;
	}

	remove = [];
	bombzones = getentarray("bombzone", "targetname");
	for(i = 0; i < bombzones.size; i++)
	{
		bombzone = bombzones[i];

		if(isdefined(bombzone.script_noteworthy))
		{
			addtolist = true;
			for(j = 0; j < accepted.size; j++)
			{
				if(bombzone.script_noteworthy == accepted[j])
				{
					addtolist = false;
					break;
				}
			}

			if(addtolist)
				remove[remove.size] = bombzone.script_noteworthy;
		}
	}

	ents = getentarray();
	for(i = 0; i < ents.size; i++)
	{
		ent = ents[i];

		if(isdefined(ent.script_exploder))
		{
			kill = false;
			for(j = 0; j < remove.size; j++)
			{
				if(ent.script_exploder == int(remove[j]))
				{
					kill = true;
					break;
				}
			}

			if(kill)
				ent delete();
		}
	}
}

bombzone_think(bombzone_other, bombnumber)
{
	level endon("round_ended");

	level.barincrement = (level.barsize / (20.0 * level.planttime[bombnumber]));
	self.progresstime = 0;

	self setteamfortrigger(game["attackers"]);
	self setHintString(&"PLATFORM_HOLD_TO_PLANT_EXPLOSIVES");

	for(;;)
	{
		self waittill("trigger", other);

		team = game["attackers"];

		if( isdefined(bombzone_other) && isdefined(bombzone_other.planting))
		{
			if ( bombzone_other.planting == true && (getcvarint("b_obj_obj_destroyBoth") == 0) )
			{
				if(isdefined(other.planticon))
					other.planticon destroy();

				continue;
			}
		}

		if ( (getcvarint("b_obj_obj_destroyBoth") == 0) && (level.bombplanted[1 - bombnumber] == true) )
		{
			if(isdefined(other.planticon))
				other.planticon destroy();
			continue;
		}

		if(isPlayer(other) && (other.pers["team"] == team) && other isOnGround())
		{
			while(other istouching(self) && isAlive(other) && other useButtonPressed())
			{
				if ( bombnumber == 0 )
					other notify("kill_check_bombzone");
				else
					other notify("kill_check_bombzone2");

				self.planting = true;
				other clientclaimtrigger(self);
				other clientclaimtrigger(bombzone_other);

				if(!isdefined(other.progressbackground))
				{
					other.progressbackground = newClientHudElem(other);
					other.progressbackground.x = 0;

					if(level.splitscreen)
						other.progressbackground.y = 70;
					else
						other.progressbackground.y = 104;

					other.progressbackground.alignX = "center";
					other.progressbackground.alignY = "middle";
					other.progressbackground.horzAlign = "center_safearea";
					other.progressbackground.vertAlign = "center_safearea";
					other.progressbackground.alpha = 0.5;
				}
				other.progressbackground setShader("black", (level.barsize + 4), 12);

				if(!isdefined(other.progressbar))
				{
					other.progressbar = newClientHudElem(other);
					other.progressbar.x = int(level.barsize / (-2.0));

					if(level.splitscreen)
						other.progressbar.y = 70;
					else
						other.progressbar.y = 104;

					other.progressbar.alignX = "left";
					other.progressbar.alignY = "middle";
					other.progressbar.horzAlign = "center_safearea";
					other.progressbar.vertAlign = "center_safearea";
				}
				other.progressbar setShader("white", 0, 8);
				other.progressbar scaleOverTime(level.planttime[bombnumber], level.barsize, 8);

				other playsound("MP_bomb_plant");
				other linkTo(self);
				other disableWeapon();

				self.progresstime = 0;
				while(isAlive(other) && other useButtonPressed() && (self.progresstime < level.planttime[bombnumber]))
				{
					self.progresstime += 0.05;
					wait 0.05;
				}

				// TODO: script error if player is disconnected/kicked here
				other clientreleasetrigger(self);
				other clientreleasetrigger(bombzone_other);

				if(self.progresstime >= level.planttime[bombnumber])
				{
					other.progressbackground destroy();
					other.progressbar destroy();
					other enableWeapon();

					// Backdraft Give points for arming a dynomite.
					other.pers["score"] += getcvarint("b_obj_bomb_arm_points");
					other.score = other.pers["score"];

					// Backdraft Unlink the player from the obj.
					other unlink();

					if(isdefined(self.target))
					{
						exploder = getent(self.target, "targetname");

						if(isdefined(exploder) && isdefined(exploder.script_exploder))
							level.bombexploder[bombnumber] = exploder.script_exploder;
					}

					self.planting = false;
					level.bombplanted[bombnumber] = true;
					self.progresstime = 0;

					objective_delete(bombnumber);

					plant = other maps\mp\_utility::getPlant();
					level.bombmodel[bombnumber] = spawn("script_model", plant.origin);
					level.bombmodel[bombnumber].angles = plant.angles;
					level.bombmodel[bombnumber] setmodel("xmodel/mp_tntbomb");
					level.bombmodel[bombnumber] playSound("Explo_plant_no_tick");

					//level.bombglow = spawn("script_model", plant.origin);
					//level.bombglow.angles = plant.angles;
					//level.bombglow setmodel("xmodel/mp_tntbomb_obj");

					objective_add(bombnumber, "current", level.bombmodel[bombnumber].origin, "objective");

					bombtrigger = getent("bombtrigger", "targetname");
					bombtrigger.origin = level.bombmodel[bombnumber].origin;

/*
					objective_add(0, "current", bombtrigger.origin, "objective");
					thread maps\mp\gametypes\_objpoints::removeTeamObjpoints("allies");
					thread maps\mp\gametypes\_objpoints::removeTeamObjpoints("axis");
					thread maps\mp\gametypes\_objpoints::addTeamObjpoint(bombtrigger.origin, "bomb", "allies", "objpoint_star");
					thread maps\mp\gametypes\_objpoints::addTeamObjpoint(bombtrigger.origin, "bomb", "axis", "objpoint_star");
*/

					//level.bombplanted = true;
					level.bombtimerstart = gettime();
					level.planting_team = other.pers["team"];

					lpselfnum = other getEntityNumber();
					lpselfguid = other getGuid();
					logPrint("A;" + lpselfguid + ";" + lpselfnum + ";" + other.pers["team"] + ";" + other.name + ";" + "bomb_plant" + "\n");

					iprintln(&"MP_EXPLOSIVESPLANTED");
					level thread soundPlanted(other);

					bombtrigger thread bomb_think(bombzone_other, bombnumber);
					bombtrigger thread bomb_countdown(self, bombzone_other, bombnumber, other);
					bombtrigger thread bomb_think_ploc(bombzone_other, bombnumber);

					//bombtrigger thread bomb_think();
					//bombtrigger thread bomb_countdown();

					level notify("bomb_planted");
					//level.clock destroy();

					return;	//TEMP, script should stop after the wait .05
				}
				else
				{
					if(isdefined(other.progressbackground))
						other.progressbackground destroy();

					if(isdefined(other.progressbar))
						other.progressbar destroy();

					other unlink();
					other enableWeapon();
				}

				wait .05;
			}

			self.planting = undefined;
			other thread check_bombzone(self, bombnumber);
		}
	}
}

check_bombzone(trigger, bombnumber)
{
	level endon("round_ended");

	// Backdraft Meh, each bomb has its own notifys.
	if ( bombnumber == 0 )
	{
		self notify("kill_check_bombzone");
		self endon("kill_check_bombzone");
	} else {
		self notify("kill_check_bombzone2");
		self endon("kill_check_bombzone2");
	}
	level endon("round_ended");

	while(isdefined(trigger) && !isdefined(trigger.planting) && self istouching(trigger) && isAlive(self))
		wait 0.05;
}

bomb_countdown(bombzone, bombzone_other, bombnumber, player)
{
	level endon("round_ended");
	level endon("intermission");

	if ( bombnumber == 0 )
		level endon( "bomb_event_defuse" );
	else
		level endon( "bomb_event2_defuse" );

	//thread showBombTimers();
	level.bombmodel[bombnumber] playLoopSound("bomb_tick");

	countdowntime = getcvarint("b_obj_bomb_time");
	wait countdowntime;

	// Backdraft Sanity checks.
	if ( !isDefined(level.bombmodel[bombnumber]) )
		return;

	// Backdraft Give points for blowing up the objective.
	player.pers["score"] += getcvarint("b_obj_bomb_blow_points");  // Default 6
	player.score = player.pers["score"];

	// bomb timer is up
	objective_delete(bombnumber);

	level.bombexploded[bombnumber] = true;
	level.bombplanted[bombnumber] = false;
	self.progresstime[bombnumber] = 0;

	// Backdraft Remove the on-screen objectives.
	thread maps\mp\gametypes\_objpoints::removeTeamObjpoints("allies");
	thread maps\mp\gametypes\_objpoints::removeTeamObjpoints("axis");
	if ( !level.bombexploded[ 1 - bombnumber] )
	{
		if ( bombnumber == 0 )
		{
			thread maps\mp\gametypes\_objpoints::addTeamObjpoint(bombzone_other.origin, "1", "allies", "objpoint_B");
			thread maps\mp\gametypes\_objpoints::addTeamObjpoint(bombzone_other.origin, "1", "axis", "objpoint_B");
		}
		else
		{
			thread maps\mp\gametypes\_objpoints::addTeamObjpoint(bombzone_other.origin, "0", "allies", "objpoint_A");
			thread maps\mp\gametypes\_objpoints::addTeamObjpoint(bombzone_other.origin, "0", "axis", "objpoint_A");
		}
	}

	if ( bombnumber == 0 )
	{
		level notify( "bomb_event", 1 );
		level notify( "bomb_event_explode" );
	}
	else
	{
		level notify( "bomb_event2", 1 );
		level notify( "bomb_event2_explode" );
	}

	//thread deleteBombTimers();

	// trigger exploder if it exists
	if(isdefined(level.bombexploder[bombnumber]))
		maps\mp\_utility::exploder(level.bombexploder[bombnumber]);

	// explode bomb
	origin = level.bombmodel[bombnumber] getorigin();
	range = 500;
	maxdamage = 2000;
	mindamage = 1000;

	level.bombmodel[bombnumber] stopLoopSound();
	//level.bombglow delete();

	playfx(level._effect["bombexplosion"], origin);
	radiusDamage(origin + (0,0,16), range, maxdamage, mindamage);
//	radiusDamage(origin, range, maxdamage, mindamage);

	level thread playSoundOnPlayers("mp_announcer_objdest");

	// Backdraft If server requires both obj to be destroyed, then check for both before ending the round.
	level.obj_destroyed++;
	if ( getcvarint("b_obj_obj_destroyBoth") == 1 )
	{
		if ( level.obj_destroyed >= 2 )
			level thread endRound(game["attackers"]);
	} else {
		level thread endRound(game["attackers"]);
	}

	// Backdraft Try to stop playSound from spawning random entities!  x_x
	self thread bomb_explosion(bombnumber);
}

bomb_explosion(bombnumber)
{
	level endon("round_ended");

	level.bombmodel[bombnumber] playSound("explo_metal_rand");
	wait 0.05;
	level.bombmodel[bombnumber] delete();
	level.bombmodel[bombnumber] = undefined;
}

bomb_think_ploc(bombzone_other, bombnumber)
{
	level endon("round_ended");

	if ( bombnumber == 0 )
		level endon( "bomb_event_explode" );
	else
		level endon( "bomb_event2_explode" );

	for (;;)
	{
		if ( level.bombplanted[bombnumber] == true )
		{
			players = getentarray("player", "classname");
			for(i = 0; i < players.size; i++)
			{
				if ( distance(players[i].origin, level.bombmodel[bombnumber].origin) < 50 )
				{
					self.origin = level.bombmodel[bombnumber].origin;
					break;
				}
			}
		}
		wait 1;
	}
}

bomb_think(bombzone, bombnumber)
{
	level endon("round_ended");

	//self setteamfortrigger(game["defenders"]);
	//self setHintString(&"PLATFORM_HOLD_TO_DEFUSE_EXPLOSIVES");

	if ( bombnumber == 0 )
		level endon( "bomb_event_explode" );
	else
		level endon( "bomb_event2_explode" );

	level.barincrement = (level.barsize / (20.0 * level.defusetime[bombnumber]));
	self.defusing[bombnumber] = false;
	self.progresstime[bombnumber] = 0;

	for(;;)
	{
		self waittill("trigger", other);

		// check for having been triggered by a valid player
		if(isPlayer(other) && (other.pers["team"] != level.planting_team) && other isOnGround())
		{
			while(isAlive(other) && other useButtonPressed())
			{
				if ( bombnumber == 0 )
					other notify("kill_check_bomb");
				else
					other notify("kill_check_bomb2");

				self.defusing[bombnumber] = true;

				other clientclaimtrigger(self);

				if(!isdefined(other.progressbackground))
				{
					other.progressbackground = newClientHudElem(other);
					other.progressbackground.x = 0;

					if(level.splitscreen)
						other.progressbackground.y = 70;
					else
						other.progressbackground.y = 104;

					other.progressbackground.alignX = "center";
					other.progressbackground.alignY = "middle";
					other.progressbackground.horzAlign= "center_safearea";
					other.progressbackground.vertAlign = "center_safearea";
					other.progressbackground.alpha = 0.5;
				}
				other.progressbackground setShader("black", (level.barsize + 4), 12);

				if(!isdefined(other.progressbar))
				{
					other.progressbar = newClientHudElem(other);
					other.progressbar.x = int(level.barsize / (-2.0));

					if(level.splitscreen)
						other.progressbar.y = 70;
					else
						other.progressbar.y = 104;

					other.progressbar.alignX = "left";
					other.progressbar.alignY = "middle";
					other.progressbar.horzAlign = "center_safearea";
					other.progressbar.vertAlign = "center_safearea";
				}
				other.progressbar setShader("white", 0, 8);
				other.progressbar scaleOverTime(level.defusetime[bombnumber] - self.progresstime[bombnumber], level.barsize, 8);

				other playsound("MP_bomb_defuse");
				other linkTo(level.bombmodel[bombnumber]);
				other disableWeapon();
				other thread check_bomb_explosion(bombnumber);

				// Backdraft Check for attack key pressed if settings specify it.
				while(isalive(other) && other useButtonPressed() && (self.progresstime[bombnumber] < level.defusetime[bombnumber]))
				{
					if ( level.bombexploded[bombnumber] == true )
						break;
					self.progresstime[bombnumber] += 0.05;
					wait 0.05;
				}

				other clientreleasetrigger(self);

				if((self.progresstime[bombnumber] >= level.defusetime[bombnumber]) && (level.bombexploded[bombnumber] == false))
				{
					other.progressbackground destroy();
					other.progressbar destroy();

					objective_delete(bombnumber);

					//thread deleteBombTimers();

					//level.bombglow delete();

					other unlink();
					other enableWeapon();
					trigger = undefined;

					// Backdraft Once planted, reset progress time.
					self.progresstime[bombnumber] = 0;

					// Backdraft Give points for disarming a dynomite.
					other.pers["score"] += getcvarint("b_obj_bomb_defuse_points");	// default 3
					other.score = other.pers["score"];

					if ( bombnumber == 0 )
					{
						level notify( "bomb_event", 0 );
						level notify( "bomb_event_defuse" );
					}
					else
					{
						level notify( "bomb_event2", 0 );
						level notify( "bomb_event2_defuse" );
					}

					// Backdraft Stop checking for bomb blow.
					other notify("cbe_stop");

					level.bombmodel[bombnumber] stopLoopSound();
					level.bombmodel[bombnumber] delete();
					level.bombmodel[bombnumber] = undefined;

					iprintln(&"MP_EXPLOSIVESDEFUSED");
					level thread playSoundOnPlayers("MP_announcer_bomb_defused");

					lpselfnum = other getEntityNumber();
					lpselfguid = other getGuid();
					logPrint("A;" + lpselfguid + ";" + lpselfnum + ";" + other.pers["team"] + ";" + other.name + ";" + "bomb_defuse" + "\n");

					level thread bombzones(bombnumber);
					return;	//TEMP, script should stop after the wait .05
				}
				else
				{
					if(isdefined(other.progressbackground))
						other.progressbackground destroy();

					if(isdefined(other.progressbar))
						other.progressbar destroy();

					other notify("cbe_stop");
					other unlink();
					other enableWeapon();
				}

				wait .05;
			}
			self.defusing[bombnumber] = false;
			other thread check_bomb(self, bombnumber);
		}
	}
}

check_bomb_explosion(bombnumber)
{
	level endon("round_ended");

	self endon("cbe_stop");
	for (;;)
	{
		if ( level.bombexploded[bombnumber] == true )
		{
			if( isdefined(self.progressbackground) )
				self.progressbackground destroy();
			if( isdefined(self.progressbar) )
				self.progressbar destroy();
			if ( isdefined(self.defuseicon) )
				self.defuseicon destroy();
		}
		wait 1;
	}
}

check_bomb(trigger, bombnumber)
{
	level endon("round_ended");

	if ( bombnumber == 0 )
	{
		self notify("kill_check_bomb");
		self endon("kill_check_bomb");
	} else {
		self notify("kill_check_bomb2");
		self endon("kill_check_bomb2");
	}
	
	while(isdefined(trigger) && trigger.defusing[bombnumber] == false && distance(self.origin, trigger.origin) < 50 && self islookingat(trigger) && isalive(self))
//	while(isdefined(trigger) && !isdefined(trigger.defusing) && self istouching(trigger) && isAlive(self))
		wait 0.05;
}

printJoinedTeam(team)
{
	if(!level.splitscreen)
	{
		if(team == "allies")
			iprintln(&"MP_JOINED_ALLIES", self);
		else if(team == "axis")
			iprintln(&"MP_JOINED_AXIS", self);
	}
}

sayObjective()
{
	wait 2;

	attacksounds["american"] = "US_mp_cmd_movein";
	attacksounds["british"] = "UK_mp_cmd_movein";
	attacksounds["russian"] = "RU_mp_cmd_movein";
	attacksounds["german"] = "GE_mp_cmd_movein";
	defendsounds["american"] = "US_mp_defendbomb";
	defendsounds["british"] = "UK_mp_defendbomb";
	defendsounds["russian"] = "RU_mp_defendbomb";
	defendsounds["german"] = "GE_mp_defendbomb";

	level playSoundOnPlayers(attacksounds[game[game["attackers"]]], game["attackers"]);
	level playSoundOnPlayers(defendsounds[game[game["defenders"]]], game["defenders"]);
}

/*
showBombTimers()
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(isdefined(player.pers["team"]) && player.pers["team"] != "spectator" && player.sessionstate == "playing")
			player showPlayerBombTimer();
	}
}

showPlayerBombTimer()
{
	timeleft = (level.bombtimer - (getTime() - level.bombtimerstart) / 1000);

	if(timeleft > 0)
	{
		self.bombtimer = newClientHudElem(self);
		self.bombtimer.x = 6;
		self.bombtimer.y = 76;
		self.bombtimer.horzAlign = "left";
		self.bombtimer.vertAlign = "top";
		self.bombtimer setClock(timeleft, level.bombtimer, "hudStopwatch", 48, 48);
	}
}

deleteBombTimers()
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
		players[i] deletePlayerBombTimer();
}

deletePlayerBombTimer()
{
	if(isdefined(self.bombtimer))
		self.bombtimer destroy();
}
*/

announceWinner(winner, delay)
{
	wait delay;

	// Announce winner
	if(winner == "allies")
		level thread playSoundOnPlayers("MP_announcer_allies_win");
	else if(winner == "axis")
		level thread playSoundOnPlayers("MP_announcer_axis_win");
	else if(winner == "draw")
		level thread playSoundOnPlayers("MP_announcer_round_draw");
}

playSoundOnPlayers(sound, team)
{
	players = getentarray("player", "classname");

	if(level.splitscreen)
	{
		if(isdefined(players[0]))
			players[0] playLocalSound(sound);
	}
	else
	{
		if(isdefined(team))
		{
			for(i = 0; i < players.size; i++)
			{
				if((isdefined(players[i].pers["team"])) && (players[i].pers["team"] == team))
					players[i] playLocalSound(sound);
			}
		}
		else
		{
			for(i = 0; i < players.size; i++)
				players[i] playLocalSound(sound);
		}
	}
}

menuAutoAssign()
{
	if(!level.xenon && isdefined(self.pers["team"]) && (self.pers["team"] == "allies" || self.pers["team"] == "axis"))
	{
		self openMenu(game["menu_team"]);
		return;
	}

	numonteam["allies"] = 0;
	numonteam["axis"] = 0;

	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(!isDefined(player.pers["team"]) || player.pers["team"] == "spectator")
			continue;

		numonteam[player.pers["team"]]++;
	}

	// if teams are equal return the team with the lowest score
	if(numonteam["allies"] == numonteam["axis"])
	{
		if(getTeamScore("allies") == getTeamScore("axis"))
		{
			teams[0] = "allies";
			teams[1] = "axis";
			assignment = teams[randomInt(2)];	// should not switch teams if already on a team
		}
		else if(getTeamScore("allies") < getTeamScore("axis"))
			assignment = "allies";
		else
			assignment = "axis";
	}
	else if(numonteam["allies"] < numonteam["axis"])
		assignment = "allies";
	else
		assignment = "axis";

	if(assignment == self.pers["team"] && (self.sessionstate == "playing" || self.sessionstate == "dead"))
	{
	    if(!isdefined(self.pers["weapon"]))
	    {
		    if(self.pers["team"] == "allies")
			    self openMenu(game["menu_weapon_allies"]);
		    else
			    self openMenu(game["menu_weapon_axis"]);
	    }

		return;
	}

	if(assignment != self.pers["team"] && (self.sessionstate == "playing" || self.sessionstate == "dead"))
	{
		self.switching_teams = true;
		self.joining_team = assignment;
		self.leaving_team = self.pers["team"];
		self suicide();
	}

	self.pers["team"] = assignment;
	self.pers["weapon"] = undefined;
	self.pers["savedmodel"] = undefined;

	self setClientCvar("ui_allow_weaponchange", "1");

	if(self.pers["team"] == "allies")
	{	
		self openMenu(game["menu_weapon_allies"]);
		self setClientCvar("g_scriptMainMenu", game["menu_weapon_allies"]);
	}
	else
	{	
		self openMenu(game["menu_weapon_axis"]);
		self setClientCvar("g_scriptMainMenu", game["menu_weapon_axis"]);
	}

	self notify("joined_team");
	self notify("end_respawn");
}

menuAllies()
{
	if(self.pers["team"] != "allies")
	{
		if(!level.xenon && !maps\mp\gametypes\_teams::getJoinTeamPermissions("allies"))
		{
			self openMenu(game["menu_team"]);
			return;
		}

		if(self.sessionstate == "playing")
		{
			self.switching_teams = true;
			self.joining_team = "allies";
			self.leaving_team = self.pers["team"];
			self suicide();
		}

		self.pers["team"] = "allies";
		self.pers["weapon"] = undefined;
		self.pers["savedmodel"] = undefined;

		self setClientCvar("ui_allow_weaponchange", "1");
		self setClientCvar("g_scriptMainMenu", game["menu_weapon_allies"]);

		self notify("joined_team");
		self notify("end_respawn");
	}

	if(!isdefined(self.pers["weapon"]))
		self openMenu(game["menu_weapon_allies"]);
}

menuAxis()
{
	if(self.pers["team"] != "axis")
	{
		if(!level.xenon && !maps\mp\gametypes\_teams::getJoinTeamPermissions("axis"))
		{
			self openMenu(game["menu_team"]);
			return;
		}

		if(self.sessionstate == "playing")
		{
			self.switching_teams = true;
			self.joining_team = "axis";
			self.leaving_team = self.pers["team"];
			self suicide();
		}

		self.pers["team"] = "axis";
		self.pers["weapon"] = undefined;
		self.pers["savedmodel"] = undefined;

		self setClientCvar("ui_allow_weaponchange", "1");
		self setClientCvar("g_scriptMainMenu", game["menu_weapon_axis"]);

		self notify("joined_team");
		self notify("end_respawn");
	}

	if(!isdefined(self.pers["weapon"]))
		self openMenu(game["menu_weapon_axis"]);
}

menuSpectator()
{
	if(self.pers["team"] != "spectator")
	{
		if(isAlive(self))
		{
			self.switching_teams = true;
			self.joining_team = "spectator";
			self.leaving_team = self.pers["team"];
			self suicide();
		}

		self.pers["team"] = "spectator";
		self.pers["weapon"] = undefined;
		self.pers["savedmodel"] = undefined;

		self.sessionteam = "spectator";
		self setClientCvar("ui_allow_weaponchange", "0");
		spawnSpectator();

		if(level.splitscreen)
			self setClientCvar("g_scriptMainMenu", game["menu_ingame_spectator"]);
		else
			self setClientCvar("g_scriptMainMenu", game["menu_ingame"]);

		self notify("joined_spectators");
	}
}

menuWeapon(response)
{
	if(!isDefined(self.pers["team"]) || (self.pers["team"] != "allies" && self.pers["team"] != "axis"))
		return;

	weapon = self maps\mp\gametypes\_weapons::restrictWeaponByServerCvars(response);

	if(weapon == "restricted")
	{
		if(self.pers["team"] == "allies")
			self openMenu(game["menu_weapon_allies"]);
		else if(self.pers["team"] == "axis")
			self openMenu(game["menu_weapon_axis"]);

		return;
	}

	if(level.splitscreen)
		self setClientCvar("g_scriptMainMenu", game["menu_ingame_onteam"]);
	else
		self setClientCvar("g_scriptMainMenu", game["menu_ingame"]);

	if(isDefined(self.pers["weapon"]) && self.pers["weapon"] == weapon)
		return;

	if(!isDefined(self.pers["weapon"]))
	{
		self.pers["weapon"] = weapon;
		spawnPlayer();
		self thread printJoinedTeam(self.pers["team"]);
	}
	else
	{
		self.pers["weapon"] = weapon;

		weaponname = maps\mp\gametypes\_weapons::getWeaponName(self.pers["weapon"]);

		if(maps\mp\gametypes\_weapons::useAn(self.pers["weapon"]))
			self iprintln(&"MP_YOU_WILL_RESPAWN_WITH_AN", weaponname);
		else
			self iprintln(&"MP_YOU_WILL_RESPAWN_WITH_A", weaponname);
	}

	self thread maps\mp\gametypes\_spectating::setSpectatePermissions();
}

soundPlanted(player)
{
	if(game["allies"] == "british")
		alliedsound = "UK_mp_explosivesplanted";
	else if(game["allies"] == "russian")
		alliedsound = "RU_mp_explosivesplanted";
	else
		alliedsound = "US_mp_explosivesplanted";

	axissound = "GE_mp_explosivesplanted";

	if(level.splitscreen)
	{
		if(player.pers["team"] == "allies")
			player playLocalSound(alliedsound);
		else if(player.pers["team"] == "axis")
			player playLocalSound(axissound);

		return;
	}
	else
	{
		level playSoundOnPlayers(alliedsound, "allies");
		level playSoundOnPlayers(axissound, "axis");

		wait 1.5;

		if(level.planting_team == "allies")
		{
			if(game["allies"] == "british")
				alliedsound = "UK_mp_defendbomb";
			else if(game["allies"] == "russian")
				alliedsound = "RU_mp_defendbomb";
			else
				alliedsound = "US_mp_defendbomb";

			level playSoundOnPlayers(alliedsound, "allies");
			level playSoundOnPlayers("GE_mp_defusebomb", "axis");
		}
		else if(level.planting_team == "axis")
		{
			if(game["allies"] == "british")
				alliedsound = "UK_mp_defusebomb";
			else if(game["allies"] == "russian")
				alliedsound = "RU_mp_defusebomb";
			else
				alliedsound = "US_mp_defusebomb";

			level playSoundOnPlayers(alliedsound, "allies");
			level playSoundOnPlayers("GE_mp_defendbomb", "axis");
		}
	}
}


setLives()
{
	if ( self.given_lives == false )
	{
		self.given_lives = true;
		if ( level.player_lives[self.pers["team"]] > 0 )
		{
			// Backdraft isNew is false if your GUID is already stored for this round.
			if ( self.isNew == true )
			{
				// Backdraft If conditions are met, give them zero lives.
				if ( getCvarInt("b_limitedlives_lateJoin") == 0 && level.roundstarted == true )
					self.lives = 0;
				else
				{
					self.lives = level.player_lives[self.pers["team"]];
					if ( level.roundstarted == true )
						self limitedLife_RoundRatio();
				}
			}
			else
			{
				// Backdraft They got disconnected during the round or joined late or something...
				// Backdraft Let them in, but prevent them from gaining more lives.
				pa_num = checkGUIDArray( self getGuid() );
				self limitedLife_RoundRatio();
				if ( self.lives > level.guid_list[pa_num + 1] )
					self.lives = level.guid_list[pa_num + 1];
			}
		}
		else
			self.lives = 0;
	}
}

// Backdraft If constantly TK, start reflecting damage.
checkTKLimit()
{
	if ( getcvarint("b_player_tklimit") > 0 )
	{
		if ( self.tk >= getcvarint("b_player_tklimit") && self.tk_reflect == false )
		{
			self iprintlnbold("^1BAD TK'ER");
			tkmode = getcvarint("b_player_tkmode");
			if ( tkmode == 0 )
				self.tk_reflect = true;
			else if ( tkmode == 1 )
			{
				self.tk_reflect = false;
				self.addPQueueTime += getcvarint("b_player_tk_spawnPenalty");
			}
		}
	}
}

// Backdraft Draw the hud that shows how many lives you have left.
limitedLife_HUD()
{
	self thread LimitedLife_HUD_cleanup();

	self endon( "llHUD_close" );
	obj_LIVES = game["obj_Text"][1];

	for (;;)
	{
		if ( self.lives <= 0 )
		{
			if ( isDefined(self.hud_lives_icon) )
				self.hud_lives_icon destroy();
			if ( isDefined(self.hud_lives) )
				self.hud_lives destroy();

			wait 2;
			continue;
		}

		if(!isdefined(self.hud_lives_icon))
		{
			self.hud_lives_icon = newClientHudElem(self);				
			self.hud_lives_icon.alignX = "left";
			self.hud_lives_icon.alignY = "top";
			self.hud_lives_icon.x = 110;
			self.hud_lives_icon.y = 391;
			self.hud_lives_icon.alpha = 0.7;
			self.hud_lives_icon.sort = 0;
			self.hud_lives_icon setShader("hud_status_dead", 32, 32);
			//self.hud_lives_icon setShader("gfx/hud/hud@status_dead.tga", 32, 32);
		}

		if (!isdefined(self.hud_lives))
		{
			self.hud_lives = newClientHudElem(self);
			self.hud_lives.alignX = "left";
			self.hud_lives.alignY = "middle";
			self.hud_lives.x = 140;		//+30
			self.hud_lives.y = 408;		//+17
			self.hud_lives.alpha = 0.65;
			if ( isDefined(obj_LIVES) )
				self.hud_lives.label = obj_LIVES;
		}
		self.hud_lives setValue( self.lives );
		wait 1;
	}
}

limitedLife_HUD_cleanup()
{
	self waittill( "llHUD_close" );
	if ( isDefined(self.hud_lives_icon) )
		self.hud_lives_icon destroy();
	if ( isDefined(self.hud_lives) )
		self.hud_lives destroy();
}

limitedLife_RoundRatio()
{
	if ( level.roundended == false )
	{
		// Backdraft Must multiply by 1.0 to force the variables to float so they divide correctly.
		max_time = 1.0 * (level.roundlength * 60);
		current_time = 1.0 * ( max_time - ((getTime() - level.starttime) / 1000) );
		self.lives = int( (level.player_lives[self.pers["team"]] * (current_time / max_time )) );
	}
	else
		self.lives = 0;
}

bodyTimeout( player, time, deathAnimDuration )
{
	body = player cloneplayer(deathAnimDuration);

	// Backdraft Play death sound.
	pTeam = player.pers["team"];
	body playSound( "generic_death_" + game[pTeam] + "_" + randomInt(level.voices[ game[pTeam] ]) );

	wait time;
	sinkBody( body );
	body delete();
}

sinkBody( body, time, distance )
{
	if ( !isDefined(time) )
		time = 1;

	if ( !isDefined(distance) )
		distance = 20;

	distance_interval = distance / (time / 0.05);
	for ( i = 0; i < distance; i += distance_interval )
	{
		body.origin = body.origin - ( 0, 0, distance_interval );
		wait 0.05;
	}
}

// Backdraft Parent = level
// Backdraft Functions that control the reinforcement queue.
joinQueue(player, killcam)
{
	self endon("spawned");

	// Backdraft Wait for the killcam thread to do its stuff.
	wait 0;

	if ( !isDefined(killcam) )
		killcam = false;

	// Backdraft Set the player state to spectator.  joinQueue is only called when you die, so this makes forceSpectator work right.
	if ( killcam == false )
	{
		self.sessionstate = "spectator";
		self.spectatorclient = 0;
		maps\mp\gametypes\_spectating::SetSpectatePermissions();	// Backdraft Yeah.
	}

	// Backdraft If the player is already in the queue, stop.
	if ( isdefined(player.joinQueue) )
		return;

	if ( player.lives <= 0 && level.player_lives[self.pers["team"]] > 0 )
	{
		// Backdraft If killcam is still running, pause until it finishes.
		if ( getcvarint("scr_killcam") == 1 )
			if ( isdefined(self.killcam) )
				self waittill("end_killcam");

		self iprintlnbold("You have no lives left");
		spawnSpectator( undefined, undefined, true );
		return;
	}

	// Respawn the player.

	self thread spawnPlayer();
}

// Backdraft Wait for the queue time then stop the queue functions.
joinQueue_timer(player)
{
	self endon("spawned");
	wait( self.queueTime_timer );

	println( "Queue timeout" );

	self notify("queue_timeout");
}

// Backdraft Remove the queue HUD.
joinQueue_cleanup(player, didSpawn)
{
	if(isdefined(self.respawn_bar_timer))
		self.respawn_bar_timer destroy();
	if(isdefined(self.respawn_text_timer))
		self.respawn_text_timer destroy();
	if(isdefined(self.respawn_title))
		self.respawn_title destroy();
	player.joinQueue = undefined;
}

// Backdraft If the player spawns, close the queue HUD.
joinQueue_spawn(player)
{
	self endon("queue_timeout");
	self waittill("spawned");
	joinQueue_cleanup(player, true);
}

checkTeamExist( team )
{
	numonteam = 0;

	// Backdraft Don't waste CPU cycles if we know the outcome already.
	if ( isDefined(level.team_exist[team]) )
		return true;

	players = getentarray( "player", "classname" );

	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(!isdefined(player.pers["team"]) || player.pers["team"] == "spectator" || player.pers["team"] != team)
			continue;

		numonteam++;
	}

	if ( !isDefined(level.team_exist[team]) && numonteam > 0 )
	{
		level.team_exist[team] = true;
		return false;
	}
	else
		return true;
}

checkTeamDead( team, nolives )
{
	dead = 0;
	numonteam = 0;

	players = getentarray( "player", "classname" );

	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(!isdefined(player.pers["team"]) || player.pers["team"] == "spectator" || player.pers["team"] != team)
			continue;

		// Backdraft Sanity check.
		if ( !isDefined(player.lives) )
			player.lives = 0;

		if ( isDefined(nolives) && nolives == true )
		{
			if ( player.sessionstate == "spectator" || player.sessionstate == "dead" )
				dead++;
		}
		else
		{
			if ( player.lives <= 0 && level.player_lives[player.pers["team"]] > 0 )
				dead++;
		}
		numonteam++;
	}

	if ( dead >= numonteam )
		return true;
	else
		return false;
}

// Backdraft Code leeched from CoD Single Player.  I had to convert the code to make it work with MP and other things.
popObject( damageDir, tModel, tOrigin )
{
	if ( !isDefined(tOrigin) )
		tOrigin = (0,0,64);

	if ( isDefined( tModel ) )
	{
		model = spawn("script_model", self.origin + tOrigin );
		model setmodel( tModel );
		model.angles = (-90,0 + randomint(90),0 + randomint(90));
		model thread objectMove( damageDir );

		wait 0.05;
	}
	return 0;
}

objectMove ( damageDir )
{
	if ( !isdefined(damageDir) )
		damageDir = (0,0,0);

	temp_vec = damageDir;
	temp_vec = vectorScale(temp_vec, 150 + randomInt(200));

	x = temp_vec[0];
	y = temp_vec[1];
	z = 100 + randomint (200);
	if (x > 0)
		self rotateroll((2*1500 + 3*randomfloat (2500)) * -1, 5,0,0);
	else
		self rotateroll(2*1500 + 3*randomfloat (2500), 5,0,0);
	
	self moveGravity ((x, y, z), 5);
	wait (5);
	self delete();
}

vectorScale (vec, scale)
{
	vec = (vec[0] * scale, vec[1] * scale, vec[2] * scale);
	return vec;
}

checkGUIDArray( GUID )
{
	if ( !isDefined(level.guid_list) || level.guid_list.size == -1 || level.guid_list.size == 1 )
		return -1;

	// Backdraft TEMP (to get bots to work)
	if ( GUID == 0 )
		return -1;

	for ( i = 0; i < level.guid_list.size; i+=2 )
		if ( GUID == level.guid_list[i] )
			return i;

	return -1;
}

updateGUIDArray( GUID, lives )
{
	if ( !isDefined(level.guid_list) || level.guid_list.size == -1 || level.guid_list.size == 1 )
		return -1;

	// Backdraft TEMP (to get bots to work)
	if ( GUID == 0 )
		return 1;

	for ( i = 0; i < level.guid_list.size; i+=2 )
	{
		if ( GUID == level.guid_list[i] )
		{
			level.guid_list[i + 1] = lives;
			return i;
		}
	}

	return -1;
}

/////////////////////////////////////////
// Cvar control function.
/////////////////////////////////////////
cvarBounds( sName, sType, vDefault, vMin, vMax )
{
	if ( isDefined(vDefault) )
		if ( getcvar(sName) == "" )
			setcvar(sName, vDefault);

	if ( !isDefined( sType ) )
		sType = "";

	if ( sType == "" || sType == "string" )
	{
		return getcvar(sName);
	}
	else if ( sType == "int" )
	{
		if ( isDefined(vMin) )
			if ( getcvarint(sName) < vMin )
				setcvar(sName, vMin);
		if ( isDefined(vMax) )
			if ( getcvarint(sName) > vMax )
				setcvar(sName, vMax);
		return getcvarint(sName);
	}
	else if ( sType == "float" )
	{
		if ( isDefined(vMin) )
			if ( getcvarfloat(sName) < vMin )
				setcvar(sName, vMin);
		if ( isDefined(vMax) )
			if ( getcvarfloat(sName) > vMax )
				setcvar(sName, vMax);
		return getcvarfloat(sName);
	}
/*
	switch( sType )
	{
		case "":
		case "string":
			return getcvar(sName);
		break;

		case "int":
			if ( isDefined(vMin) )
				if ( getcvarint(sName) < vMin )
					setcvar(sName, vMin);
			if ( isDefined(vMax) )
				if ( getcvarint(sName) > vMax )
					setcvar(sName, vMax);
			return getcvarint(sName);
		break;

		case "float":
			if ( isDefined(vMin) )
				if ( getcvarfloat(sName) < vMin )
					setcvar(sName, vMin);
			if ( isDefined(vMax) )
				if ( getcvarfloat(sName) > vMax )
					setcvar(sName, vMax);
			return getcvarfloat(sName);
		break;
	}
*/
	return undefined;
}

// Backdraft IW is really gay, so I have to put this script here and modify it to make
// Backdraft the spawn protection code work.  =/
friendicon_init()
{
	// Draws a team icon over teammates
	if(getCvar("scr_drawfriend") == "")
		setCvar("scr_drawfriend", "1");
	level.drawfriend = getCvarInt("scr_drawfriend");

	switch(game["allies"])
	{
	case "american":
		game["headicon_allies"] = "headicon_american";
		precacheHeadIcon(game["headicon_allies"]);
		break;
	
	case "british":
		game["headicon_allies"] = "headicon_british";
		precacheHeadIcon(game["headicon_allies"]);
		break;
	
	case "russian":
		game["headicon_allies"] = "headicon_russian";
		precacheHeadIcon(game["headicon_allies"]);
		break;
	}

	assert(game["axis"] == "german");
	game["headicon_axis"] = "headicon_german";
	precacheHeadIcon(game["headicon_axis"]);

//	level thread friendicon_onPlayerConnect();

//	for(;;)
//	{
//		friendicon_updateFriendIconSettings();
//		wait 5;
//	}
}

friendicon_onPlayerConnect()
{
	for(;;)
	{
		level waittill("connecting", player);

		player thread friendicon_onPlayerSpawned();
		player thread friendicon_onPlayerKilled();
	}
}

friendicon_onPlayerSpawned()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("spawned_player");
		
		self thread friendicon_showFriendIcon();
	}
}

friendicon_onPlayerKilled()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("killed_player");
		self.headicon = "";
	}
}	

friendicon_showFriendIcon()
{
	if(level.drawfriend)
	{
		if(self.pers["team"] == "allies")
		{
			self.headicon = game["headicon_allies"];
			self.headiconteam = "allies";
		}
		else
		{
			self.headicon = game["headicon_axis"];
			self.headiconteam = "axis";
		}
	}
}
	
friendicon_updateFriendIconSettings()
{
	drawfriend = getCvarFloat("scr_drawfriend");
	if(level.drawfriend != drawfriend)
	{
		level.drawfriend = drawfriend;

		friendicon_updateFriendIcons();
	}
}

friendicon_updateFriendIcons()
{
	// for all living players, show the appropriate headicon
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if(isDefined(player.pers["team"]) && player.pers["team"] != "spectator" && player.sessionstate == "playing")
		{
			if(level.drawfriend)
			{
				if(player.pers["team"] == "allies")
				{
					player.headicon = game["headicon_allies"];
					player.headiconteam = "allies";
				}
				else
				{
					player.headicon = game["headicon_axis"];
					player.headiconteam = "axis";
				}
			}
			else
			{
				players = getentarray("player", "classname");
				for(i = 0; i < players.size; i++)
				{
					player = players[i];

					// Backdraft GAY
					if ( player.invulnerable == true )
						continue;

					if(isDefined(player.pers["team"]) && player.pers["team"] != "spectator" && player.sessionstate == "playing")
						player.headicon = "";
				}
			}
		}
	}
}
